var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { customElement, html, state, when } from '../../../../external/lit/index.js';
import { UmbLitElement } from '../../../core/lit-element/index.js';
let UmbTiptapToolbarButtonElement = class UmbTiptapToolbarButtonElement extends UmbLitElement {
    constructor() {
        super(...arguments);
        this.isActive = false;
        this.#onEditorUpdate = () => {
            if (this.api && this.editor && this.manifest) {
                this.isActive = this.api.isActive(this.editor);
            }
        };
    }
    connectedCallback() {
        super.connectedCallback();
        if (this.editor) {
            this.editor.on('selectionUpdate', this.#onEditorUpdate);
            this.editor.on('update', this.#onEditorUpdate);
        }
    }
    disconnectedCallback() {
        super.disconnectedCallback();
        if (this.editor) {
            this.editor.off('selectionUpdate', this.#onEditorUpdate);
            this.editor.off('update', this.#onEditorUpdate);
        }
    }
    #onEditorUpdate;
    render() {
        const label = this.localize.string(this.manifest?.meta.label);
        return html `
			<uui-button
				compact
				look=${this.isActive ? 'outline' : 'default'}
				label=${label}
				title=${label}
				?disabled=${this.api?.isDisabled(this.editor)}
				@click=${() => this.api?.execute(this.editor)}>
				${when(this.manifest?.meta.icon, (icon) => html `<umb-icon name=${icon}></umb-icon>`, () => html `<span>${label}</span>`)}
			</uui-button>
		`;
    }
};
__decorate([
    state()
], UmbTiptapToolbarButtonElement.prototype, "isActive", void 0);
UmbTiptapToolbarButtonElement = __decorate([
    customElement('umb-tiptap-toolbar-button')
], UmbTiptapToolbarButtonElement);
export { UmbTiptapToolbarButtonElement };
export { UmbTiptapToolbarButtonElement as element };
